import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["Solid でリストをレンダリングするには ", jsx(_components.code, {
        children: "<For>"
      }), " を使用しますが、Solid には ", jsx(_components.code, {
        children: "<Index>"
      }), " コンポーネントもあり、特定の状況下で再レンダリングを少なくできます。"]
    }), "\n", jsxs(_components.p, {
      children: ["配列が更新されたとき、", jsx(_components.code, {
        children: "<For>"
      }), " コンポーネントは参照等式を使用して、要素を配列の最後の状態と比較します。しかし、これは必ずしも望ましいとは限りません。"]
    }), "\n", jsxs(_components.p, {
      children: ["JavaScript では、プリミティブ（文字列や数値など）は常に値で比較されます。プリミティブな値や配列の配列に対して ", jsx(_components.code, {
        children: "<For>"
      }), " を使用すると、不要なレンダリングが多く発生する可能性があります。もし、", jsx(_components.code, {
        children: "<For>"
      }), " を使って、文字列のリストをそれぞれ編集可能な ", jsx(_components.code, {
        children: "<input>"
      }), " フィールドにマッピングした場合、その値を変更するたび ", jsx(_components.code, {
        children: "<input>"
      }), " が再作成されることになります。"]
    }), "\n", jsxs(_components.p, {
      children: ["このような場合のために、", jsx(_components.code, {
        children: "<Index>"
      }), " コンポーネントが用意されています。経験則では、プリミティブを扱うときには ", jsx(_components.code, {
        children: "<Index>"
      }), " を使用します。"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), " each={", jsx(_components.span, {
          className: "hljs-title function_",
          children: "cats"
        }), "()}>{", jsxs(_components.span, {
          className: "hljs-function",
          children: ["(", jsx(_components.span, {
            className: "hljs-params",
            children: "cat, i"
          }), ") =>"]
        }), "\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          }), "\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "a"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "target"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "\"_blank\""
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "href"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{"
            }), "`", jsx(_components.span, {
              className: "hljs-attr",
              children: "https:"
            }), "//", jsx(_components.span, {
              className: "hljs-attr",
              children: "www.youtube.com"
            }), "/", jsx(_components.span, {
              className: "hljs-attr",
              children: "watch"
            }), "?", jsx(_components.span, {
              className: "hljs-attr",
              children: "v"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "${cat().id}"
            }), "`}>"]
          }), "\n      {i + 1}: {cat().name}\n    ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "a"
            }), ">"]
          }), "\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "li"
            }), ">"]
          })]
        }), "\n}</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Index"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["このシグネチャは ", jsx(_components.code, {
        children: "<For>"
      }), " と似ていますが、今回はアイテムが Signal であり、インデックスが固定されています。レンダリングされた各ノードは、配列のスポットに対応します。そのスポットのデータが変更されるたびに、Signal は更新されます。"]
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "<For>"
      }), " は配列の各データを扱い、そのデータの位置を変更できます。", jsx(_components.code, {
        children: "<Index>"
      }), " は配列の各インデックスを扱い、各インデックスにあるコンテンツを変更できます。"]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-12bf04b4.js.map
