import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "Иногда наши компоненты и элементы получают несколько атрибутов и в таком случае имеет смысл оформить их в виде объекта, а не передавать по одному. Это довольно частый когда мы оборачиваем DOM элемент в компонент, например, при создании систем дизайна."
    }), "\n", jsxs(_components.p, {
      children: ["Когда нам это необходимо мы можем использовать оператор расширения ", jsx(_components.code, {
        children: "..."
      }), " (", jsx(_components.code, {
        children: "spread operator"
      }), ")."]
    }), "\n", jsx(_components.p, {
      children: "Таким образом мы можем удобно передавать несколько атрибутов:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Info"
        }), " {...pkg} />\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-1cb9e8b6.js.map
