import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "アプリケーションを構築する際には、モジュール性や再利用性を高めるためにコードを分割する必要があります。Solid では、主にコンポーネントを作成することでこれを実現しています。"
    }), "\n", jsxs(_components.p, {
      children: ["コンポーネントは、これまでに使用してきた ", jsx(_components.code, {
        children: "HelloWorld()"
      }), " のような関数です。コンポーネントが特別なのは、通常 JSX を返し、他のコンポーネントの JSX から呼び出すことができるからです。"]
    }), "\n", jsxs(_components.p, {
      children: ["今回の例では、", jsx(_components.code, {
        children: "Nested"
      }), " コンポーネントをアプリに追加してみましょう。このコンポーネントは別のファイルで定義しましたが、複数のコンポーネントを同じファイルに入れることができます。まず、コンポーネントをインポートする必要があります:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " ", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Nested"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "\"./nested\""
        }), ";\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "次に、JSX にコンポーネントを追加する必要があります。先ほどと同様に、返したい要素が複数あるので、それらを Fragment にまとめます:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "function"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "App"
        }), "(", jsx(_components.span, {
          className: "hljs-params"
        }), ") {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\n    ", jsxs(_components.span, {
          className: "xml",
          children: [jsx(_components.span, {
            className: "hljs-tag",
            children: "<>"
          }), "\n      ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          }), "This is a Header", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "h1"
            }), ">"]
          }), "\n      ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "Nested"
            }), " />"]
          }), "\n    ", jsx(_components.span, {
            className: "hljs-tag",
            children: "</>"
          })]
        }), "\n  );\n}\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["親コンポーネントが最初にレンダリングされたときに ", jsx(_components.code, {
        children: "Nested()"
      }), " 関数が実行され、それ以降は呼び出されません。すべての更新は Solid のリアクティビティシステムによって適用されますが、これについては次のレッスンで説明します。"]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-25730eb0.js.map
