import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["Иногда вам будет необходимо передать ", jsx(_components.code, {
        children: "ref"
      }), " из компонента в его родителя. Для этого мы можем использовать ", jsx(_components.code, {
        children: "ref"
      }), " так же, как мы использовали его на нативных элементах. Мы можем использовать ", jsx(_components.code, {
        children: "ref"
      }), " как переменную, которая будет определена или передавать его как функцию-коллбек (", jsx(_components.code, {
        children: "callback function"
      }), ")."]
    }), "\n", jsxs(_components.p, {
      children: ["Для того, чтобы это работало автору компонента необходимо прикрепить его к внутреннему элементу. Для этого мы используем ", jsx(_components.code, {
        children: "props.ref"
      }), ". Такая запись превращает любой из варианта создания ", jsx(_components.code, {
        children: "ref"
      }), " и превращает его в коллбек (", jsx(_components.code, {
        children: "callback"
      }), "). Эта деталь, скорее всего будет скрыта от вас, так как в большинстве случаев вы будете прикреплять ", jsx(_components.code, {
        children: "ref"
      }), " элементам или компонентам в виде атрибута."]
    }), "\n", jsxs(_components.p, {
      children: ["Для того, чтобы наш логотип снова был анимирован мы должны передать ", jsx(_components.code, {
        children: "ref"
      }), " в ", jsx(_components.code, {
        children: "canvas.tsx"
      }), ":"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<canvas ref={props.", jsx(_components.span, {
          className: "hljs-property",
          children: "ref"
        }), "} width=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"256\""
        }), " height=", jsx(_components.span, {
          className: "hljs-string",
          children: "\"256\""
        }), " />\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-4c06ec56.js.map
