import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["В Solid всего несколько методов жизненного цикла, которые контролируются нашей системой реактивности. Реактивная система создается и обновляется синхронно, поэтому всё планирование сводится к ", jsx(_components.code, {
        children: "Эффектам"
      }), ", которые заполняют очередь обновления."]
    }), "\n", jsxs(_components.p, {
      children: ["Для удобства разработчиков мы выделили специальный ", jsx(_components.code, {
        children: "createEffect"
      }), " который называется ", jsx(_components.code, {
        children: "onMount"
      }), " который никогда не будет перезапущен. Это простой ", jsx(_components.code, {
        children: "Эффект"
      }), ", применяя который, вы можете быть уверены, что он будет запущен единожды при начальной отрисовке:"]
    }), "\n", jsxs(_components.p, {
      children: ["Давайте используем хук ", jsx(_components.code, {
        children: "onMount"
      }), " чтобы получить несколько фотографий:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-keyword",
          children: "async"
        }), " () => {\n\t", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " res = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fetch"
        }), "(", jsx(_components.span, {
          className: "hljs-string",
          children: "`https://jsonplaceholder.typicode.com/photos?_limit=20`"
        }), ");\n\t", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setPhotos"
        }), "(", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " res.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "json"
        }), "());\n});\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Жизненные циклы выполняются только в браузере, поэтому размещенный в ", jsx(_components.code, {
        children: "onMount"
      }), " код не запускается на сервере во время SSR. Несмотря на то, что в этом примере мы выполняем просто загрузку данных, обычно мы используем ", jsx(_components.code, {
        children: "Ресурс"
      }), " Solid для настоящей координации между сервером и браузером."]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-a6f8c8f5.js.map
