import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "コンポーネントや要素が不定の数の属性を受け入れる場合、それらを個別に渡すのではなく、オブジェクトとして渡す方が理にかなっている場合があります。これは、DOM 要素をコンポーネントでラップする場合に特に当てはまり、デザインシステムを作る際にはよくあることです。"
    }), "\n", jsxs(_components.p, {
      children: ["これには、スプレッド演算子 ", jsx(_components.code, {
        children: "..."
      }), " を使用します。"]
    }), "\n", jsx(_components.p, {
      children: "不定の数のプロパティを持つオブジェクトを渡すことができます:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Info"
        }), " {...pkg} />\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-a79ab2e7.js.map
