import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["일부 프레임워크는 사이드 이펙트나 라이프사이클 메서드의 반환값을 클린업 메서드로 사용합니다. Solid 렌더 트리의 모든 것이 (비활성일 수도 있음) 이펙트 안에 있고 중첩될 수 있기 때문에, ", jsx(_components.code, {
        children: "onCleanup"
      }), " 함수를 일급 메서드로 만들었습니다. 모든 스코프에서 이 함수를 호출할 수 있으며, 해당 스코프가 재평가를 위해 트리거되고 최종적으로 폐기될 때 실행됩니다."]
    }), "\n", jsx(_components.p, {
      children: "이 함수는 이펙트, 컴포넌트, 커스텀 디렉티브 뿐만 아니라 리액티브 시스템의 동기 실행이 일어나는 거의 모든 곳에서 사용하면 됩니다."
    }), "\n", jsxs(_components.p, {
      children: ["1장에 있었던 시그널 예제는 클린업 메서드를 사용해 정리하지 않았습니다. ", jsx(_components.code, {
        children: "setInterval"
      }), " 호출을 다음과 같이 변경해 문제를 해결해 보겠습니다:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " timer = ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "setInterval"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setCount"
        }), "(", jsx(_components.span, {
          className: "hljs-title function_",
          children: "count"
        }), "() + ", jsx(_components.span, {
          className: "hljs-number",
          children: "1"
        }), "), ", jsx(_components.span, {
          className: "hljs-number",
          children: "1000"
        }), ");\n", jsx(_components.span, {
          className: "hljs-title function_",
          children: "onCleanup"
        }), "(", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsx(_components.span, {
          className: "hljs-built_in",
          children: "clearInterval"
        }), "(timer));\n"]
      })
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-c81f9af5.js.map
