import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: ["JSX에서는 자바스크립트를 사용해 템플릿의 논리 흐름을 제어할 수 있습니다. 그러나, 가상 DOM이 없는 경우, ", jsx(_components.code, {
        children: "Array.prototype.map"
      }), "를 아무 생각없이 사용하면 업데이트할 때마다 모든 DOM 노드를 새로 생성하고 버리게 될 수 있습니다. 리액티브 라이브러리에서는 대신 템플릿 헬퍼를 사용하는 것이 일반적입니다. Solid에서는 헬퍼를 컴포넌트로 래핑합니다."]
    }), "\n", jsxs(_components.p, {
      children: ["가장 기본적인 제어 흐름은 조건문입니다. Solid의 컴파일러는 똑똑하게도 삼항 연산자(", jsx(_components.code, {
        children: "a ? b : c"
      }), ")와 불 표현식(", jsx(_components.code, {
        children: "a && b"
      }), ")을 최적화해서 처리합니다. 하지만, Solid의 ", jsx(_components.code, {
        children: "<Show>"
      }), " 컴포넌트를 사용하는 것이 가독성이 더 좋을 때도 있습니다."]
    }), "\n", jsx(_components.p, {
      children: "이 예에서는, 현재 상태(사용자가 로그인했는지 여부)를 반영하는 적절한 버튼만 표시하고자 합니다. JSX를 다음과 같이 업데이트하세요:"
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: ["<", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), "\n  when={", jsx(_components.span, {
          className: "hljs-title function_",
          children: "loggedIn"
        }), "()}\n  fallback={", jsx(_components.span, {
          className: "hljs-function",
          children: "() =>"
        }), " ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{toggle}"
            }), ">"]
          }), "Log in", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), ">"]
          })]
        }), "}\n>\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{toggle}"
            }), ">"]
          }), "Log out", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), ">"]
          })]
        }), "\n</", jsx(_components.span, {
          className: "hljs-title class_",
          children: "Show"
        }), ">\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "fallback"
      }), " prop은 ", jsx(_components.code, {
        children: "else"
      }), "처럼 동작하며, ", jsx(_components.code, {
        children: "when"
      }), "에 넘겨진 조건이 ", jsx(_components.code, {
        children: "false"
      }), "인 경우에만 표시됩니다."]
    }), "\n", jsx(_components.p, {
      children: "이제 버튼을 클릭하면 예상한 대로 버튼의 상태가 왔다 갔다하는 것을 볼 수 있습니다."
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-d320ac21.js.map
