import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsx(_components.p, {
      children: "Solid 中只有少量的生命周期，因为一切的存活销毁都由响应系统控制。响应系统是同步创建和更新的，因此唯一的调度就是将逻辑写到更新结束的 Effect 中。"
    }), "\n", jsxs(_components.p, {
      children: ["我们发现处理简单任务的开发者通常不会这么想，所以为了让事情变得更容易一些，我们将非跟踪（从不重新运行）", jsx(_components.code, {
        children: "createEffect"
      }), " 调用取了一个别名 —— ", jsx(_components.code, {
        children: "onMount"
      }), "。它只是一个 Effect 调用，但你可以放心使用它，一旦所有初始渲染完成，它只会在组件中运行一次。"]
    }), "\n", jsxs(_components.p, {
      children: ["让我们使用 ", jsx(_components.code, {
        children: "onMount"
      }), " 钩子来获取一些照片："]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-title function_",
          children: "onMount"
        }), "(", jsx(_components.span, {
          className: "hljs-keyword",
          children: "async"
        }), " () => {\n  ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " res = ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "fetch"
        }), "(\n    ", jsx(_components.span, {
          className: "hljs-string",
          children: "`https://jsonplaceholder.typicode.com/photos?_limit=20`"
        }), "\n  );\n  ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "setPhotos"
        }), "(", jsx(_components.span, {
          className: "hljs-keyword",
          children: "await"
        }), " res.", jsx(_components.span, {
          className: "hljs-title function_",
          children: "json"
        }), "());\n});\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["生命周期仅在浏览器中运行，因此将代码放在 ", jsx(_components.code, {
        children: "onMount"
      }), " 中的好处是在 SSR 期间不在服务器上运行。即使我们在这个例子中进行数据获取，通常我们使用 Solid 的 Resource 来实现真正的服务器/浏览器协调。"]
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-e6cbec97.js.map
