import { jsx, jsxs, Fragment } from 'solid-jsx/jsx-runtime';

/*@jsxRuntime automatic @jsxImportSource solid-jsx*/
const toc = [];
function _createMdxContent(props) {
  const _components = Object.assign({
    p: "p",
    code: "code",
    pre: "pre",
    span: "span"
  }, props.components);
  return jsxs(Fragment, {
    children: [jsxs(_components.p, {
      children: [jsx(_components.code, {
        children: "Контекст"
      }), " - отличный инструмент для хранилищ. Он обрабатывает внедрение, создает реактивный графы, автоматически управляет удалением и не имеет никакой цены за использование, учитывая точный рендеринг Solid."]
    }), "\n", jsxs(_components.p, {
      children: ["Впрочем, в большинстве случаев вы можете просто использовать Сигналы для простых вещей. Как вы уже могли догадаться, простой ", jsx(_components.code, {
        children: "Стор"
      }), " это просто ", jsx(_components.code, {
        children: "Сигнал"
      }), ":"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-js",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " { createSignal } ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'solid-js'"
        }), ";\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "export"
        }), " ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "default"
        }), " ", jsx(_components.span, {
          className: "hljs-title function_",
          children: "createSignal"
        }), "(", jsx(_components.span, {
          className: "hljs-number",
          children: "0"
        }), ");\n\n", jsx(_components.span, {
          className: "hljs-comment",
          children: "// в любом месте в вашем приложении:"
        }), "\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "import"
        }), " counter ", jsx(_components.span, {
          className: "hljs-keyword",
          children: "from"
        }), " ", jsx(_components.span, {
          className: "hljs-string",
          children: "'./counter'"
        }), ";\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " [count, setCount] = counter;\n"]
      })
    }), "\n", jsxs(_components.p, {
      children: ["Реактивность в Solid это универсальный концепт. Нам не важно, где мы создаем ", jsx(_components.code, {
        children: "Сигнал"
      }), " внутри компонентов или за его границами. В Solid нет разницы между глобальной и локальной областью видимости (", jsx(_components.code, {
        children: "global vs local scope"
      }), "). Единственным ограничением является то, что все реактивные примитивы (", jsx(_components.code, {
        children: "Сигналы"
      }), ", ", jsx(_components.code, {
        children: "Эффекты"
      }), ", ", jsx(_components.code, {
        children: "Мемо"
      }), ") должны быть созданы внутри реактивного корня (", jsx(_components.code, {
        children: "createRoot"
      }), "). Методы ", jsx(_components.code, {
        children: "render"
      }), " в Solid делают это автоматически."]
    }), "\n", jsxs(_components.p, {
      children: ["В этом уроке ", jsx(_components.code, {
        children: "counter.tsx"
      }), " является таким глобальным хранилищем. Мы можем использовать его, изменив наш компонент в main.tsx на:"]
    }), "\n", jsx(_components.pre, {
      children: jsxs(_components.code, {
        className: "hljs language-jsx",
        children: [jsx(_components.span, {
          className: "hljs-keyword",
          children: "const"
        }), " { count, doubleCount, increment } = counter;\n\n", jsx(_components.span, {
          className: "hljs-keyword",
          children: "return"
        }), " (\n  ", jsxs(_components.span, {
          className: "xml",
          children: [jsxs(_components.span, {
            className: "hljs-tag",
            children: ["<", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "type"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "\"button\""
            }), " ", jsx(_components.span, {
              className: "hljs-attr",
              children: "onClick"
            }), "=", jsx(_components.span, {
              className: "hljs-string",
              children: "{increment}"
            }), ">"]
          }), "\n    {count()} {doubleCount()}\n  ", jsxs(_components.span, {
            className: "hljs-tag",
            children: ["</", jsx(_components.span, {
              className: "hljs-name",
              children: "button"
            }), ">"]
          })]
        }), "\n);\n"]
      })
    }), "\n", jsx(_components.p, {
      children: "Поэтому при использовании ваших собственных более сложных глобальных хранилищ, содержащих вычисления, обязательно создайте корень. А ещё лучше просто используйте Контекст."
    })]
  });
}
function MDXContent(props = {}) {
  const {wrapper: MDXLayout} = props.components || ({});
  return MDXLayout ? jsx(MDXLayout, Object.assign({}, props, {
    children: jsx(_createMdxContent, props)
  })) : _createMdxContent(props);
}

export { MDXContent as default, toc };
//# sourceMappingURL=lesson-eee01d38.js.map
